# Support drivers based on what's available
%global have_cassandra 0
%global have_redis     ( "%{?rhel}" != "5" )

Name:		perl-Apache-Session-NoSQL
Version:	0.1
Release:	2%{?dist}
Summary:	NoSQL implementation of Apache::Session
Group:		Development/Libraries
License:	GPL+ or Artistic
URL:		http://search.cpan.org/dist/Apache-Session-NoSQL/
Source0:	http://search.cpan.org/CPAN/authors/id/G/GU/GUIMARD/Apache-Session-NoSQL-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	perl
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(Apache::Session)
BuildRequires:	perl(Apache::Session::Generate::MD5)
BuildRequires:	perl(Apache::Session::Lock::Null)
BuildRequires:	perl(Apache::Session::Serialize::Base64)
BuildRequires:	perl(base)
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
# Test Suite
BuildRequires:	perl(Test::More)
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Apache::Session::NoSQL)-Driver = %{version}-%{release}

%description
NoSQL implementation of Apache::Session. Sessions are stored in NoSQL
bases, either Redis or Cassandra.

%if %{have_cassandra}
%package -n perl-Apache-Session-Cassandra
Summary:	Cassandra driver for Apache::Session::NoSQL
Group:		Development/Libraries
BuildRequires:	perl(Net::Cassandra)
Requires:	perl-Apache-Session-NoSQL = %{version}-%{release}
Provides:	perl(Apache::Session::NoSQL)-Driver = %{version}-%{release}

%description -n perl-Apache-Session-Cassandra
%{summary}.
%endif

%if %{have_redis}
%package -n perl-Apache-Session-Redis
Summary:	Redis driver for Apache::Session::NoSQL
Group:		Development/Libraries
BuildRequires:	perl(Redis)
Requires:	perl-Apache-Session-NoSQL = %{version}-%{release}
Provides:	perl(Apache::Session::NoSQL)-Driver = %{version}-%{release}

%description -n perl-Apache-Session-Redis
%{summary}.
%endif

%prep
%setup -q -n Apache-Session-NoSQL-%{version}

%if ! %{have_cassandra} && ! %{have_redis}
%{error:At least one of Cassandra or Redis must be available}
exit 1
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -name .packlist -exec rm -f {} \;
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%doc Changes README examples/
%dir %{perl_vendorlib}/Apache/
%dir %{perl_vendorlib}/Apache/Session/
%dir %{perl_vendorlib}/Apache/Session/Store/
%dir %{perl_vendorlib}/Apache/Session/Store/NoSQL/
%{perl_vendorlib}/Apache/Session/NoSQL.pm
%{perl_vendorlib}/Apache/Session/Store/NoSQL.pm
%{_mandir}/man3/Apache::Session::NoSQL.3*
%{_mandir}/man3/Apache::Session::Store::NoSQL.3*

%if %{have_cassandra}
%files -n perl-Apache-Session-Cassandra
%{perl_vendorlib}/Apache/Session/Cassandra.pm
%{perl_vendorlib}/Apache/Session/Store/NoSQL/Cassandra.pm
%{_mandir}/man3/Apache::Session::Cassandra.3*
%{_mandir}/man3/Apache::Session::Store::NoSQL::Cassandra.3*
%else
%exclude %{perl_vendorlib}/Apache/Session/Cassandra.pm
%exclude %{perl_vendorlib}/Apache/Session/Store/NoSQL/Cassandra.pm
%exclude %{_mandir}/man3/Apache::Session::Cassandra.3*
%exclude %{_mandir}/man3/Apache::Session::Store::NoSQL::Cassandra.3*
%endif

%if %{have_redis}
%files -n perl-Apache-Session-Redis
%{perl_vendorlib}/Apache/Session/Redis.pm
%{perl_vendorlib}/Apache/Session/Store/NoSQL/Redis.pm
%{_mandir}/man3/Apache::Session::Redis.3*
%{_mandir}/man3/Apache::Session::Store::NoSQL::Redis.3*
%else
%exclude %{perl_vendorlib}/Apache/Session/Redis.pm
%exclude %{perl_vendorlib}/Apache/Session/Store/NoSQL/Redis.pm
%exclude %{_mandir}/man3/Apache::Session::Redis.3*
%exclude %{_mandir}/man3/Apache::Session::Store::NoSQL::Redis.3*
%endif

%changelog
* Thu Jan 29 2015 Paul Howarth <paul@city-fan.org> - 0.1-2
- Incorporate review feedback (#1186725)
  - Ship Changes, README and examples files
  - BR: perl(base)

* Wed Jan 28 2015 Paul Howarth <paul@city-fan.org> - 0.1-1
- Initial RPM version
